-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009 - 2019 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

return {
	name = "Vault Test Zone!",
	level_range = {1, 50},
	level_scheme = "player",
	max_level = 10,
	actor_adjust_level = function(zone, level, e) return zone.base_level + e:getRankLevelAdjust() + level.level-1 + rng.range(-1,2) end,
	width = 50, height = 50,
	-- all_remembered = true,
	all_lited = true,
	no_level_connectivity = true,
	
	nicer_tiler_overlay = "DungeonWallsGrass",
	min_material_level = function() return 1 end,
	max_material_level = function() return 5 end,
--	events_by_level = true,
--	_max_level_generation_count = 2,
	
	generator =  {
		map = {
			class = "engine.generator.map.Roomer",
			nb_rooms = 5,
			edge_entrances = {2,8},
			rooms = {"random_room", "rocky_snowy_trees", "lesser_vault"},
			lesser_vaults_list = {"test_vault"},
			greater_vaults_list = {"test_vault"},
			['.'] = "ROCKY_GROUND",
			['T'] = "ROCKY_SNOWY_TREE",
			['#'] = "MOUNTAIN_WALL",
			up = "ROCKY_UP2",
			down = "ROCKY_DOWN8",
			door = "ROCKY_GROUND",
		},
		actor = {
			class = "mod.class.generator.actor.Random",
			nb_npc = {0, 0},
		},
		object = {
			class = "engine.generator.object.Random",
			nb_object = {0, 0},
		},
		trap = {
			class = "engine.generator.trap.Random",
			nb_trap = {0, 0},
		},
	},
	post_process = function(level) -- testing level generation failure
		-- if level.level >=3 then level.force_recreate = true end
	end,
}
